# remirepo spec file for php-pear
# adapted for SCL from
#
# Fedora spec file for php-pear
#
# License: MIT
# http://opensource.org/licenses/MIT
#
# Please preserve changelog entries
#
%if 0%{?scl:1}
%scl_package             php-pear
%else
%global pkg_name         %{name}
%global _root_sysconfdir %{_sysconfdir}
%global _root_bindir     %{_bindir}
%endif

%global peardir %{_datadir}/pear
%global metadir %{_localstatedir}/lib/pear

%global getoptver 1.4.1
%global arctarver 1.4.3
# https://pear.php.net/bugs/bug.php?id=19367
# Structures_Graph 1.0.4 - incorrect FSF address
%global structver 1.1.1
%global xmlutil   1.4.3
%global manpages  1.10.0

# Tests are only run with rpmbuild --with tests
# Can't be run in mock / koji because PEAR is the first package
%global with_tests 0%{?_with_tests:1}

%global macrosdir %(d=%{_rpmconfigdir}/macros.d; [ -d $d ] || d=%{_root_sysconfdir}/rpm; echo $d)

%{!?pecl_xmldir: %global pecl_xmldir %{_sharedstatedir}/php/peclxml}

#global pearprever dev3

Summary: PHP Extension and Application Repository framework
Name: %{?scl_prefix}php-pear
Version: 1.10.5
Release: 7.4
Epoch: 1
# PEAR, PEAR_Manpages, Archive_Tar, XML_Util, Console_Getopt are BSD
# Structures_Graph is LGPLv3+
License: BSD and LGPLv3+
Group: Development/Languages
URL: http://pear.php.net/package/PEAR
Source0: http://download.pear.php.net/package/PEAR-%{version}%{?pearprever}.tgz
# wget https://raw.githubusercontent.com/pear/pear-core/stable/install-pear.php
Source1: install-pear.php
Source3: cleanup.php
Source10: pear.sh
Source11: pecl.sh
Source12: peardev.sh
Source13: macros.pear
Source14: macros-f24.pear
Source21: http://pear.php.net/get/Archive_Tar-%{arctarver}.tgz
Source22: http://pear.php.net/get/Console_Getopt-%{getoptver}.tgz
Source23: http://pear.php.net/get/Structures_Graph-%{structver}.tgz
Source24: http://pear.php.net/get/XML_Util-%{xmlutil}.tgz
Source25: http://pear.php.net/get/PEAR_Manpages-%{manpages}.tgz

# https://github.com/pear/pear-core/pull/71
Patch0:   https://patch-diff.githubusercontent.com/raw/pear/pear-core/pull/71.patch

BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: %{?scl_prefix}php(language) > 5.4
BuildRequires: %{?scl_prefix}php-cli
BuildRequires: %{?scl_prefix}php-xml
BuildRequires: gnupg
# For pecl_xmldir macro
BuildRequires: %{?scl_prefix}php-devel
%if %{with_tests}
BuildRequires:  %{_bindir}/phpunit
%endif

# Temporary
%{?scl:Obsoletes: %{scl_prefix}fakepear}

Provides:  %{?scl_prefix}php-pear(Console_Getopt) = %{getoptver}
Provides:  %{?scl_prefix}php-pear(Archive_Tar) = %{arctarver}
Provides:  %{?scl_prefix}php-pear(PEAR) = %{version}
Provides:  %{?scl_prefix}php-pear(Structures_Graph) = %{structver}
Provides:  %{?scl_prefix}php-pear(XML_Util) = %{xmlutil}
Provides:  %{?scl_prefix}php-pear(PEAR_Manpages) = %{manpages}

Provides:  %{?scl_prefix}php-composer(pear/console_getopt) = %{getoptver}
Provides:  %{?scl_prefix}php-composer(pear/archive_tar) = %{arctarver}
Provides:  %{?scl_prefix}php-composer(pear/pear-core-minimal) = %{version}
Provides:  %{?scl_prefix}php-composer(pear/structures_graph) = %{structver}
Provides:  %{?scl_prefix}php-composer(pear/xml_util) = %{xmlutil}

%if "%{?vendor}" == "Remi Collet" && 0%{!?scl:1}
# From other third party
Obsoletes: php53-pear  <= %{epoch}:%{version}
Obsoletes: php53u-pear <= %{epoch}:%{version}
Obsoletes: php54-pear  <= %{epoch}:%{version}
Obsoletes: php54w-pear <= %{epoch}:%{version}
Obsoletes: php55u-pear <= %{epoch}:%{version}
Obsoletes: php55w-pear <= %{epoch}:%{version}
Obsoletes: php56u-pear <= %{epoch}:%{version}
Obsoletes: php56w-pear <= %{epoch}:%{version}
Obsoletes: php70u-pear <= %{epoch}:%{version}
Obsoletes: php70w-pear <= %{epoch}:%{version}
Obsoletes: php71u-pear <= %{epoch}:%{version}
Obsoletes: php71w-pear <= %{epoch}:%{version}
%endif

%{?_sclreq:Requires: %{?scl_prefix}runtime%{?_sclreq}}
# Archive_Tar requires 5.2
# XML_Util, Structures_Graph require 5.3
# Console_Getopt requires 5.4
# PEAR requires 5.4
Requires:  %{?scl_prefix}php(language) > 5.4
Requires:  %{?scl_prefix}php-cli
# phpci detected extension
# PEAR (date, spl always builtin):
Requires:  %{?scl_prefix}php-ftp
Requires:  %{?scl_prefix}php-pcre
Requires:  %{?scl_prefix}php-posix
Requires:  %{?scl_prefix}php-tokenizer
Requires:  %{?scl_prefix}php-xml
Requires:  %{?scl_prefix}php-zlib
# Console_Getopt: pcre
# Archive_Tar: pcre, posix, zlib
Requires:  %{?scl_prefix}php-bz2
# Structures_Graph: none
# XML_Util: pcre
# optional: overload and xdebug
%if 0%{?fedora} >= 21 && 0%{!?scl:1}
%global with_html_dir 0
# for /var/www/html ownership
Requires: httpd-filesystem
%else
%global with_html_dir 1
%endif


%description
PEAR is a framework and distribution system for reusable PHP
components.  This package contains the basic PEAR components.

%prep
%setup -cT

# Create a usable PEAR directory (used by install-pear.php)
for archive in %{SOURCE0} %{SOURCE21} %{SOURCE22} %{SOURCE23} %{SOURCE24} %{SOURCE25}
do
    tar xzf  $archive --strip-components 1 || tar xzf  $archive --strip-path 1
    file=${archive##*/}
    [ -f LICENSE ] && mv LICENSE LICENSE-${file%%-*}
    [ -f README ]  && mv README  README-${file%%-*}

    tar xzf $archive 'package*xml'
    [ -f package2.xml ] && mv package2.xml ${file%%-*}.xml \
                        || mv package.xml  ${file%%-*}.xml
done
cp %{SOURCE1} .

# apply patches on used PEAR during install
# None \o/

sed -e 's/@SCL@/%{?scl:%{scl}_}/' \
    -e 's:@VARDIR@:%{_localstatedir}:' \
    -e 's:@BINDIR@:%{_bindir}:' \
    -e 's:@ETCDIR@:%{_sysconfdir}:' \
    -e 's:@PREFIX@:%{_prefix}:' \
%if 0%{?fedora} >= 24
    %{SOURCE14} | tee macros.pear
%else
    %{SOURCE13} | tee macros.pear
%endif


%build
# This is an empty build section.


%install
rm -rf $RPM_BUILD_ROOT

export PHP_PEAR_SYSCONF_DIR=%{_sysconfdir}
export PHP_PEAR_SIG_KEYDIR=%{_sysconfdir}/pearkeys
export PHP_PEAR_SIG_BIN=%{_root_bindir}/gpg
export PHP_PEAR_INSTALL_DIR=%{peardir}

# 1.4.11 tries to write to the cache directory during installation
# so it's not possible to set a sane default via the environment.
# The ${PWD} bit will be stripped via relocate.php later.
export PHP_PEAR_CACHE_DIR=${PWD}%{_localstatedir}/cache/php-pear
export PHP_PEAR_TEMP_DIR=/var/tmp

install -d $RPM_BUILD_ROOT%{peardir} \
           $RPM_BUILD_ROOT%{_localstatedir}/cache/php-pear \
           $RPM_BUILD_ROOT%{_localstatedir}/www/html \
           $RPM_BUILD_ROOT%{_localstatedir}/lib/pear/pkgxml \
%if 0%{?fedora} < 24
           $RPM_BUILD_ROOT%{_docdir}/pecl \
           $RPM_BUILD_ROOT%{_datadir}/tests/pecl \
%endif
           $RPM_BUILD_ROOT%{_sysconfdir}/pear

export INSTALL_ROOT=$RPM_BUILD_ROOT

%{_bindir}/php --version

%{_bindir}/php -dmemory_limit=64M -dshort_open_tag=0 -dsafe_mode=0 \
         -d 'error_reporting=E_ALL&~E_DEPRECATED' -ddetect_unicode=0 \
         install-pear.php --force \
                 --dir      %{peardir} \
                 --cache    %{_localstatedir}/cache/php-pear \
                 --config   %{_sysconfdir}/pear \
                 --bin      %{_bindir} \
                 --www      %{_localstatedir}/www/html \
                 --doc      %{_docdir}/pear \
                 --test     %{_datadir}/tests/pear \
                 --data     %{_datadir}/pear-data \
                 --metadata %{metadir} \
                 --man      %{_mandir} \
                 %{SOURCE0} %{SOURCE21} %{SOURCE22} %{SOURCE23} %{SOURCE24} %{SOURCE25}

# Replace /usr/bin/* with simple scripts:
install -m 755 %{SOURCE10} $RPM_BUILD_ROOT%{_bindir}/pear
install -m 755 %{SOURCE11} $RPM_BUILD_ROOT%{_bindir}/pecl
install -m 755 %{SOURCE12} $RPM_BUILD_ROOT%{_bindir}/peardev
# Fix path in SCL
for exe in pear pecl peardev; do
    sed -e 's:/usr:%{_prefix}:' \
        -i $RPM_BUILD_ROOT%{_bindir}/$exe
done

# Sanitize the pear.conf
%{_bindir}/php %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf %{_datadir}

# Display configuration for debug
%{_bindir}/php -r "print_r(unserialize(substr(file_get_contents('$RPM_BUILD_ROOT%{_sysconfdir}/pear.conf'),17)));"


install -m 644 -D macros.pear \
           $RPM_BUILD_ROOT%{macrosdir}/macros.%{?scl_prefix}pear

# apply patches on installed PEAR tree
pushd %{buildroot}%{peardir}
patch --no-backup --fuzz 0 -p1 < %{PATCH0}
popd

# Why this file here ?
rm -rf $RPM_BUILD_ROOT/.depdb* $RPM_BUILD_ROOT/.lock $RPM_BUILD_ROOT/.channels $RPM_BUILD_ROOT/.filemap

# Need for re-registrying XML_Util
install -pm 644 *.xml $RPM_BUILD_ROOT%{_localstatedir}/lib/pear/pkgxml

# make the cli commands available in standard root for SCL build
%if 0%{?scl:1}
install -m 755 -d $RPM_BUILD_ROOT%{_root_bindir}
ln -s %{_bindir}/pear      $RPM_BUILD_ROOT%{_root_bindir}/%{scl_prefix}pear
%endif


%check
# Check that no bogus paths are left in the configuration, or in
# the generated registry files.
grep $RPM_BUILD_ROOT $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf && exit 1
grep %{_libdir} $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf && exit 1
grep '"/tmp"' $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf && exit 1
grep /usr/local $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf && exit 1
grep -rl $RPM_BUILD_ROOT $RPM_BUILD_ROOT && exit 1


%if %{with_tests}
cp /etc/php.ini .
echo "include_path=.:$RPM_BUILD_ROOT%{peardir}:/usr/share/php" >>php.ini
export PHPRC=$PWD/php.ini
LOG=$PWD/rpmlog
ret=0

cd $RPM_BUILD_ROOT%{_datadir}/tests/pear/Structures_Graph/tests
phpunit \
   AllTests || ret=1

cd $RPM_BUILD_ROOT%{_datadir}/tests/pear/XML_Util/tests
%{_bindir}/php \
   $RPM_BUILD_ROOT/usr/share/pear/pearcmd.php \
   run-tests \
   | tee $LOG

cd $RPM_BUILD_ROOT%{_datadir}/tests/pear/Console_Getopt/tests
%{_bindir}/php \
   $RPM_BUILD_ROOT/usr/share/pear/pearcmd.php \
   run-tests \
   | tee -a $LOG

grep "FAILED TESTS" $LOG && ret=1

exit $ret
%else
echo 'Test suite disabled (missing "--with tests" option)'
%endif


%if 0%{?fedora} >= 24
## TODO: silent the pecl commands

# Register newly installed PECL packages
%transfiletriggerin -- %{pecl_xmldir}
while read file; do
  %{_bindir}/pecl install --nodeps --soft --force --register-only --nobuild "$file" || :
done

# Unregister to be removed PECL packages
# Reading the xml file to retrieve channel and package name
%transfiletriggerun -- %{pecl_xmldir}
%{_bindir}/php -r '
while ($file=fgets(STDIN)) {
  $file = trim($file);
  $xml = simplexml_load_file($file);
  if (isset($xml->channel) &&  isset($xml->name)) {
    printf("%s/%s\n", $xml->channel, $xml->name);
  } else {
    fputs(STDERR, "Bad pecl package file ($file)\n");
  }
}' | while read  name; do
  %{_bindir}/pecl uninstall --nodeps --ignore-errors --register-only "$name" || :
done
%endif


%if 0%{?fedora} < 25
%pre
# Manage relocation of metadata, before update to pear
if [ -d %{peardir}/.registry -a ! -d %{metadir}/.registry ]; then
  mkdir -p %{metadir}
  mv -f %{peardir}/.??* %{metadir}
fi


%post
# force new value as pear.conf is (noreplace)
current=$(%{_bindir}/pear config-get test_dir system)
if [ "$current" != "%{_datadir}/tests/pear" ]; then
%{_bindir}/pear config-set \
    test_dir %{_datadir}/tests/pear \
    system >/dev/null || :
fi

current=$(%{_bindir}/pear config-get data_dir system)
if [ "$current" != "%{_datadir}/pear-data" ]; then
%{_bindir}/pear config-set \
    data_dir %{_datadir}/pear-data \
    system >/dev/null || :
fi

current=$(%{_bindir}/pear config-get metadata_dir system)
if [ "$current" != "%{metadir}" ]; then
%{_bindir}/pear config-set \
    metadata_dir %{metadir} \
    system >/dev/null || :
fi

current=$(%{_bindir}/pear config-get -c pecl doc_dir system)
if [ "$current" != "%{_docdir}/pecl" ]; then
%{_bindir}/pear config-set \
    -c pecl \
    doc_dir %{_docdir}/pecl \
    system >/dev/null || :
fi

current=$(%{_bindir}/pear config-get -c pecl test_dir system)
if [ "$current" != "%{_datadir}/tests/pecl" ]; then
%{_bindir}/pear config-set \
    -c pecl \
    test_dir %{_datadir}/tests/pecl \
    system >/dev/null || :
fi
%endif


%postun
if [ $1 -eq 0 -a -d %{metadir}/.registry ] ; then
  rm -rf %{metadir}/.registry
fi


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%{peardir}
%dir %{metadir}
%{metadir}/.channels
%verify(not mtime size md5) %{metadir}/.depdb
%verify(not mtime)          %{metadir}/.depdblock
%verify(not mtime size md5) %{metadir}/.filemap
%verify(not mtime)          %{metadir}/.lock
%{metadir}/.registry
%{metadir}/pkgxml
%{_bindir}/*
%config(noreplace) %{_sysconfdir}/pear.conf
%{macrosdir}/macros.%{?scl_prefix}pear
%dir %{_localstatedir}/cache/php-pear
%if %{with_html_dir}
%dir %{_localstatedir}/www/html
%endif
%dir %{_sysconfdir}/pear
%{!?_licensedir:%global license %%doc}
%license LICENSE*
%doc README*
%dir %{_docdir}/pear
%doc %{_docdir}/pear/*
%if 0%{?fedora} < 24
%dir %{_docdir}/pecl
%dir %{_datadir}/tests
%dir %{_datadir}/tests/pecl
%endif
%{_datadir}/tests/pear
%{_datadir}/pear-data
%if 0%{?scl:1}
%dir %{_localstatedir}/www
%{_root_bindir}/%{scl_prefix}pear
%endif
%{_mandir}/man1/pear.1*
%{_mandir}/man1/pecl.1*
%{_mandir}/man1/peardev.1*
%{_mandir}/man5/pear.conf.5*


%changelog
* Mon Mar 19 2018 cs@linux-administrator.com
- update PEAR to 1.10.5
- update XML_Util to 1.4.3
- update Archive_Tar to 1.4.3
* Thu Aug 18 2016 cs@linux-administrator.com
- initial import
